<?php
    // ***********************************************************************************
    // LMO-Spielverlegung
    // ***********************************************************************************
    // Copyright etc. spare ich mir.
    // Bitte eMehl an mich, wer's einsetzt.
    // Fr Verbesserungsvorschlge immer offen, Script ist noch nicht perfekt.
    // ***********************************************************************************
    // Liga-Manager Online von Frank Hollwitz
    // http://www.hollwitz.de
    // by: Peter Scherb, 12/2002
    // Anschauen: www.peterscherb.de/svj
    // ***********************************************************************************
    // LMO_SPIELEVERLEGUNG.PHH
    // ***********************************************************************************
    // Funktion:
    // -----------------------------------------------------------------------------------
    // Anzeige der verlegten Spiele
    // ***********************************************************************************
    // Beschreibung:
    // -----------------------------------------------------------------------------------
    // Ins LMO-Verzeichnis kopieren.
    // Das Script luft durch die angegebenen Ligen, sucht nach Unterschiede im Spieltag
    // Dx mit der Anstozeit Ax und Gxy = -1 und listet die mit dem neuen Datum auf.
    //
    // Einige Routinen hab' ich mir vom LMO-Viewer abgekuckt (Danke Bernd)
    // Auch kann die Steuerungsdatei vom LMO-Viewer bernommen werden,
    // ansonsten hier der Aufbau:
    //
    // <Pfad_zur_Liga_innerhalb_LMO>/<Datei_Name_der_Liga>;<ID_Nr1>[;<ID_Nr1>...]
    // ***
    //
    // z.B. ligen/C2-KS4.l98;4
    // Liganame: C2-KS4.i98
    // Mannschaft-Nr.: 4
    // Endekennzeichen: ***
    //
    // Wie gesagt, Aufbau wie die Viewer-Datei
    // Weitere Variablen sind im Einstellungsbereich beschrieben
    // ***********************************************************************************
    // Aufruf:
    // -----------------------------------------------------------------------------------
    // ZeigeSpielVerleg([Art], [LigaFile], [Mannschaften])
    //
    // Art: 1 = Einzelne Liga, LigaFile = Name der Liga mit Pfad, relativ zum Script
    //      2 = Ligen, die sich in der Datei LigaFile befinden
    //
    // LigaFile: Je nach Art, einzelnes Liga-File oder Datei mit den auszugebenden Ligen
    //
    // Mannschaften: nur bei Art=1 String mit den auszugebenden Mannschaften, durch ;
    //               getrennt, sonst ""
    //
    // ***********************************************************************************

    function ZeigeSpielVerleg($art, $incFile, $strMannschaft)
    {
        // Einstellungsbereich
        $PfadScr    = "../lmo/";
                                           // Pfad zur Script (MIT / am Ende!) relativ zum Aufrufscript
        $textNixVerlegt = "Keine Spielverlegungen vorhanden";
                                           // Text fr keine Spielverlegungen
        // 0=nein, 1=ja
        $anzFavorit = 1;                   // Favorit-Anzeige: 0=nein, 1=ja
        $anzLink    = 1;                   // Anzeige Verlinkung des Spieltags mit der Tabelle
        $anzDatHerv = 0;                   // Anzeige des Datums hervorgehoben:
        $anzNichtBekannt = 1;              // Anzeige unbekannter Spieltage:
        $spTagWoche = 0;                   // Spieltag geht ber eine ganze Woche
                                           // Achtung: Sonntag ist der 1. Tag der Woche
        // --------------------------------
        $anzHervSt  = "<b><font color='#FF80FF'>";
                                           // Wie wird angezeigt (html) Anfang
        $anzHervEnd = "</font></b>";
                                           // Wie wird angezeigt (html) Ende
        $spez       = "*";                 // Spezialzeichen, welches nicht in den ...
                                           // ... Mannschaftsnamen auftauchen darf zur ...
                                           // ... Kennzeichnung des Dateiendes
        // Ende Einstellungsbereich
        // -------------------------------------------------------------------------------------------------

        // ----------------------------------------------------------------------------
        // Allgemeine Variablen
        $designFile = $PfadScr . "lmo_ped.css";
        $design     = '<link rel=stylesheet type="text/css" href="' . $designFile . '">';
    	$tabBreite  = 8;
    	$fClass     = "lmost5";
    	$anfZeile   = "<tr><td  class=" . $fClass . " align=left>";
    	$zwiSpaLi   = "</td><td class=" . $fClass . " align=left>";
    	$zwiSpaZent = "</td><td class=" . $fClass . " align=center>";
    	$zwiSpaRe   = "</td><td class=" . $fClass . " align=right>";
    	$endZeile   = "</td></tr>";
    	$pedVS      = "0.99c";
        // Ende allgemeine Variablen
        // ----------------------------------------------------------------------------

        // Array fllen:
        // 1 = Einzelmannschaft, $incFile = einzelnes Ergebnis-File
        switch ($art)
        {
            case 1:
            {
                $arrMeineMannschaften = explode(";", $strMannschaft);
                // Einlesen der Verlegungen in's Ergebnisarray
                $arrErgeb = array_merge($arrErgeb, GetVerlegData($incFile, $arrMeineMannschaften, $spTagWoche));
            }
            break;
            // 2 = mehrere Mannschaften, $incFile = Datei mit Ligen
            case 2:
            {
                // Liga-File auf einmal einlesen
                $arrFile = file(chop($incFile));
                // Einzelne Liga-Files und Favoriten auslesen
            	for ($i = 0; $i <= sizeof($arrFile); $i++)
                {
                    // Endekennung erreicht ?
                    if (substr($arrFile[$i], 0, 1) == $spez)
                    {
                        break;
                    } // Ende if ... (Endekennung erreicht ?)

                    // Kommentar ?
                    if (substr($arrFile[$i], 0, 2) != "//" && chop($arrFile[$i]) != "" )
                    {
                        $ligaPfad = $PfadScr . substr($arrFile[$i], 0, strpos($arrFile[$i], ";"));
                        // Favoriten, durch ; getrennt, extrahieren
                        $arrMannschaft = explode(";", substr($arrFile[$i], strpos($arrFile[$i], ";") + 1));
                        // Beim 1. Durchlauf -> Arrays anlegen ...
                        if (!is_array($arrLigaFile))
                        {
                            $arrLigaFile = array(chop($ligaPfad));
                            $arrMeineMannschaften = array($arrMannschaft);
                        }
                        else // ... ansonsten -> Arrays verbinden
                        {
                            array_push($arrLigaFile, chop($ligaPfad));
                            array_push($arrMeineMannschaften, $arrMannschaft);
                        } // Ende if ... (Beim 1. Durchlauf -> Array anlegen ...)

                    } // Ende if ... (Kommentar ?)

                } // Ende for ... (Einzelne Liga-Files und Favoriten auslesen)


                // Einlesen der Verlegungen in's Ergebnisarray
                for ($i = 0; $i < sizeof($arrLigaFile); $i++)
                {
                    $arrErgeb = array_merge($arrErgeb, GetVerlegData($arrLigaFile[$i], $arrMeineMannschaften[$i], $spTagWoche));
                } // Ende for ... Einlesen der Verlegungen in's Ergebnisarray
            }
         }
        // ------------------------------------------------------------------------------------------------
        // Ausgabe
    	echo $design;
        echo "<body topmargin='0' leftmargin='0'><div align='center'><center>";
        echo "<table><tr><th colspan='9' class=lmomain0>" . "Spielverlegungen";

            $LigaCounter = -1;
            // Ergebnis-Array durchwandern
            for ($i = 0; $i < sizeof($arrErgeb); $i++)
            {

                // Ligenname nur wenn neue Liga
                if ($i > 0 && $arrErgeb[$i][0] != $arrErgeb[$i - 1][0] || $i == 0)
                {
                    echo "<tr><td colspan=" . $tabBreite . " class=lmost4>" . $arrErgeb[$i][0] . "</td></tr>";
                    $LigaCounter++;
                } // Ende if ... (Ligenname nur wenn neue Liga)

                // Anzeige nicht bekannter Spiele ?
                $anzVorhanden = 0;
                if ($arrErgeb[$i][2] != "" || ($arrErgeb[$i][2] == "" && $anzNichtBekannt == 1))
                {
                    ++$anzVorhanden;
                    $spielTag = $arrErgeb[$i][5];
                    // Ausgabe in der Tabelle
            		echo $anfZeile;
            		
            		// Tabellen-Link anzeigen ?
            		if ($anzLink)
            		{
                        echo "<a href=" . $PfadScr . "lmo.php?file=" . $arrLigaFile[$LigaCounter] . "&action=results&st=" . $spielTag . " target='_self' title='Tabelle/Begegnungen des $spielTag. Spieltages anzeigen'>";
                    } // Ende if ... (Tabellen-Link anzeigen)

                    echo "Spieltag " . $spielTag;
            		
            		// Tabellen-Link anzeigen ?
            		if ($anzLink)
            		{
                        echo "</a>";
                    } // Ende if ... (Tabellen-Link anzeigen)

                    echo $zwiSpaLi;

                    // Datum hervorgehoben ?
                    if ($anzDatHerv)
                    {
                        echo $anzHervSt;
                    } // Ende if ... (Datum hervorgehoben ?)

                    echo $arrErgeb[$i][1];

                    // Datum hervorgehoben ?
                    if ($anzDatHerv)
                    {
                        echo $anzHervEnd;
                    } // Ende if ... (Datum hervorgehoben ?)

                    echo $zwiSpaZent . "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp";
                    if (vglDateGT($arrErgeb[$i][1], makeDate($arrErgeb[$i][2]))&& $arrErgeb[$i][2] != "")
                    {
                        echo "vorverlegt auf";
                    }
                    else
                    {
                        echo "verlegt auf";
                    }

                     echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp";
                     echo $zwiSpaRe;

                    // Datum hervorgehoben ?
                    if ($anzDatHerv)
                    {
                        echo $anzHervSt;
                    } // Ende if ... (Datum hervorgehoben ?)

                    if ($arrErgeb[$i][2] == "")
                    {
                        echo "nicht bekannt";
                    }
                    else
                    {
                        echo date("d.m.Y H:i", $arrErgeb[$i][2]);
                    }

                    // Datum hervorgehoben ?
                    if ($anzDatHerv)
                    {
                        echo $anzHervEnd;
                    } // Ende if ... (Datum hervorgehoben ?)

                    // Anzeige des Favoriten
                    $istFavorit = $anzFavorit && chop($arrErgeb[$i][3]) == chop($arrErgeb[$i][8]);
                    $anzBold = "";
                    if ($istFavorit) { $anzBold = "<b>"; }
                    echo $zwiSpaRe . $anzBold . $arrErgeb[$i][3];
                    if ($istFavorit) { echo "</b>"; }

                    echo $zwiSpaZent . " - ";

                    // Anzeige des Favoriten
                    $istFavorit = $anzFavorit && chop($arrErgeb[$i][4]) == chop($arrErgeb[$i][8]);
                    $anzBold = "";
                    if ($istFavorit) { $anzBold = "<b>"; }
                    echo $zwiSpaLi . $anzBold . $arrErgeb[$i][4];
                    if ($istFavorit) { echo "</b>"; }
                    echo $endZeile;
                } // Ende if ... (Anzeige nicht bekannter Spiele ?)
                
            } // Ende for ... (Ergebnis-Array durchwandern)

            // Wenn nix verlegt -> anzeigen
            if ($anzVorhanden == 0)
            {
                echo "<tr>";
                    echo $zwiSpaZent;
                        echo $textNixVerlegt;
                    echo "</td>";
                echo "</tr>";
            } // Ende if ... (Wenn nix verlegt -> anzeigen)

            // Fuzeile
            echo "<tr>";
                echo "<td  class=lmomain2 colspan='9' align=center>";
                    echo "<style='font-size:2px'>";
                    echo "<a href='http://www.peterscherb.de/svj' target='_blank'>";
                    echo "LMO-Spielverlegung V " . $pedVS;
                    echo "</a> &copy; " . date("m") . "/" . date("Y") . " <a href='mailto:Peter.Scherb@PeterScherb.de'>";
                    echo "eMehl an Ped</a>";
                echo "</td>";
            echo "</tr>";
        echo "</table>";
    }

    // ------------------------------------------------------------------------------------------------
    function GetVerlegData($arrLigaFile, $arrMeineMannschaften, $flSpTagWoche)
    {
        // Datei komplett einlesen
    	$arrFile = file($arrLigaFile);

    	$ligaName      = substr($arrFile[2], 5);
    	$spiele        = (int)substr($arrFile[6], 8);
        $sizeOfArrFile = sizeof($arrFile);
        
        // "Header" einlesen
    	for ($i = 0; $i < $sizeOfArrFile; $i++)
        {
    		$check2 = substr($arrFile[$i], 0, 2);
    		$check3 = substr($arrFile[$i], 0, 3);
    		$check4 = substr($arrFile[$i], 0, 4);
    		$check5 = substr($arrFile[$i], 0, 5);
    		$check6 = substr($arrFile[$i], 0, 6);
    		$check7 = substr($arrFile[$i], 0, 7);
    		$check8 = substr($arrFile[$i], 0, 8);
    		$check9 = substr($arrFile[$i], 0, 9);
    		
    		// Anzahl der Spieltage
    	    if($check6 == "Rounds")
            {
    	    	$spieltage = (int)substr($arrFile[$i], 7);
    	    } // Ende if ... (Anzahl der Spieltage)
    	    
    	    // Anzahl Teams feststellen
    	    if($check5 == "Teams")
            {
    	    	$anzMannschaften = substr($arrFile[$i], 6, 2);
    	    } // Ende if ... (Anzahl Teams feststellen)
    	
    	    // Favorit feststellen
    	    if($check7 == "favTeam")
            {
    	    	$favTeam = (int)substr($arrFile[$i], 8, 2);
    	    } // Ende if ... (Anzahl Teams feststellen)
    	
    	    // Alle Teams ins Array einlesen
    		if ($check7 == "[Teams]")
            {
    			$i++;
    			for ($j = 1; $j <= $anzMannschaften; $j++)
                {
    				if ($j < 10)
                    {
    					$arrMannsch[$j] = chop(substr($arrFile[$i], 2));
    				}
    				if ($j > 9)
                    {
    					$arrMannsch[$j] = chop(substr($arrFile[$i], 3));
    				}
    	        $i++;
    		    }
    		} // Ende if ... (Alle Teams ins Array einlesen)
    		
    		// hat die Spieltag-Sektion erreicht -> raus
    		if ($check8 == "[Round1]")
            {
                $spielTag = 1;
                break;
            } // Ende if ... (hat die Spieltag-Sektion erreicht -> raus)
            
        } // Ende for ... ("Header" einlesen)

		// Favorit als Mannschafts-Name
        $favTeam = $arrMannsch[$favTeam];

        // Schleife Spieltage
        $sizeOfArrFile = sizeof($arrFile);
        for ($spTag = $i; $spTag <= $sizeOfArrFile; $spTag++)
        {
            $arrFile[$spTag] = chop($arrFile[$spTag]);
            // Bentigte Daten, auer Anstozeit, einlesen
    		while (substr($arrFile[$spTag], 0, 2) != "AT")
            {
                // Schlel
    			$key = substr($arrFile[$spTag], 0, 2);
    			// Wert
    			$value  = chop(substr($arrFile[$spTag], strpos($arrFile[$spTag], "=") + 1));
    			if ($key == "D1") { $datum1   = (string)$value; }
    			if ($key == "D2") { $datum2   = (string)$value; }
    			if ($key == "TA") { $heimId   = (int)$value ;   }
    			if ($key == "TB") { $gastId   = (int)$value ;   }
    			if ($key == "GA") { $heimTore = (int)$value;    }
	       		if ($key == "GB") { $gastTore = (int)$value;    }

    			if (substr($arrFile[$spTag], 0, 6) == "[Round")
                {
    				$spielTag = substr($arrFile[$spTag], 6);
    				$spielTag = substr($spielTag, 0, strpos($spielTag, "]"));
    				//$spielTag++;
    			}
    			$spTag++;
    			// Ende erreicht ?
    			if ($spTag > $sizeOfArrFile)
                {
                    break;
                }
            }
            // Anstozeit = Ende Spiel-Sektion
            if (substr($arrFile[$spTag], 0, 2) == "AT")
            {
                // Anstozeit extrahieren
                $anStZeit = (int)substr($arrFile[$spTag], strpos($arrFile[$spTag], "=") + 1);
                // Kalenderwoche des Original-Datums
                $week1 = WoY($datum1);
                // Wochentag des Original-Datums
                $weekDay1 = DoW($datum1);
                // Woche des AT-Datums
                $week2 = strftime("%W", $anStZeit);
                // Wochentag des AT-Datums
                $weekDay2 = date("w", $anStZeit);
                //echo "Datum1: " . $datum1 . " : dow() -> " . $weekDay1 . " : Woche: " . $week1 . " | " . "AT: " . date("d.m.Y", $anStZeit) . " : dow()->" . $weekDay2 . " : Woche: " . $week2 . "|" . vglDate($datum1, makeDate($anStZeit)) . "|<br>";
                
                $flVerlegt = 0;
                if ($datum1 != "" && vglDate($datum1, makeDate($anStZeit))) // $week1 != $week2 && ($weekDay1 >= 5 || $weekDay1 == 0) && $weekDay2 > 0 && $weekDay2 < 5)
                {
                    if ($week1 != $week2)
                    {
                        $flVerlegt = 1;
                    }
                    else if ($flSpTagWoche == 0 && $week1 == $week2)
                    {
                        if (($weekDay1 >= 5 || $weekDay1 == 0) && $weekDay2 < 5 && $weekDay2 !=0)
                        {
                            $flVerlegt = 1;
                        }
                        else if ($weekDay1 < 5 &&  $weekDay1 !=0)
                        {
                            $flVerlegt = 1;
                        }
                    }
                }
                // Datum liegt spter als heute
                $laterToday = ($anStZeit >= mktime(0, 0, 0, date("m"), date("d"), date("Y")));
                // Mannschaftsarray durchlaufen
                for ($j = 0; $j < sizeof($arrMeineMannschaften); $j++)
                {
                    if ($heimTore == -1 && $gastTore == -1 && $flVerlegt == 1 && ($heimId == $arrMeineMannschaften[$j] || $gastId == $arrMeineMannschaften[$j]))
                    //if ($flVerlegt == 1)
                    {
                        if (!is_array($arrErgeb))
                        {
                            $arrErgeb = array(array($ligaName, $datum1, $anStZeit, $arrMannsch[$heimId], $arrMannsch[$gastId], $spielTag, $spBericht, $notitz, $favTeam));
                        }
                        else
                        {
                            $arrDummy = array(array($ligaName, $datum1, $anStZeit, $arrMannsch[$heimId], $arrMannsch[$gastId], $spielTag, $spBericht, $notitz, $favTeam));
                        }
                        // Falls Ergebnis schon vorhanden (tritt nur bei mehreren Mannschaften auf)
                        // nicht eintragen
                        for ($k = 0; $k < sizeof($arrErgeb); $k++)
                        {
                            $flag = 0;
                            if ($arrMannsch[$heimId] == $arrErgeb[$k][3] && $arrMannsch[$gastId] == $arrErgeb[$k][4])
                            {
                                $flag = 0;
                                break;
                            }
                            else
                            {
                                $flag = 1;
                            }
                        }
                        if ($flag == 1)
                        {
                            $arrErgeb = array_merge($arrErgeb, $arrDummy);
                        }
                    }
                }
            }
        }
        return $arrErgeb;
    }
    
    
    function makeDate($timeStamp)
    {
        $ret = 0;
        if ($timeStamp != 0)
        {
            $date    = date("d.m.Y", $timeStamp);
            $arrDate = explode(".", chop($date));
            $ret = date("d.m.Y", mktime(0, 0, 0, $arrDate[1], $arrDate[0], $arrDate[2]));
        }
        return $ret;
    }


    function vglDate($datumStamp1, $datumStamp2)
    {
        //echo $datumStamp1 ." - " . $datumStamp2 . "<br>";
        return (int)(chop($datumStamp1) != chop($datumStamp2));
    }

    function vglDateGT($dateString1, $dateString2)
    {

        $arrDate1 = explode(".", chop($dateString1));
        $arrDate2 = explode(".", chop($dateString2));
        return (int)(mktime(0, 0, 0, $arrDate1[1], $arrDate1[0], $arrDate1[2]) > (mktime(0, 0, 0, $arrDate2[1], $arrDate2[0], $arrDate2[2])));
    }


    // Day of Week
    function DoW($dateString)
    {
        $ret = 0;
        if (chop($dateString) != "")
        {
            $arrDate = explode(".", chop($dateString));
            $arrGetDate = getdate(mktime(0, 0, 0, $arrDate[1], $arrDate[0], $arrDate[2]));
            $ret = $arrGetDate[wday];
        }
        return ($ret);
    }
    
    // Week of Year
    function WoY($dateString)
    {
        $arrDate = explode(".", chop($dateString));
        return(strftime("%W", mktime(0, 0, 0, $arrDate[1], $arrDate[0], $arrDate[2])));
    }
?>